
import java.awt.Window;
import java.awt.event.*;
import java.awt.geom.*;
import java.awt.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.plaf.ScrollBarUI;


public class Draw extends Frame implements ActionListener{

    DrawCanvas drawingCanvas;
    
    DrawControls controls;
    Dialog dg = new Dialog(this);
    Dialog window = new Dialog(this);
    Dialog hwindow = new Dialog(this);
    TextField tt = new TextField();
       
    static FileDialog dialog;
    static FileDialog save;
    
    int undecorate = 0;
     
    public void destroy() {
        remove(drawingCanvas);
        remove(controls);
    }

    public static void main(String args[]) {
        final Draw drawtest = new Draw();
        try{
        	
        	UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
		}
		catch(Exception eee){}
		
        drawtest.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
            AnyBox ab = new AnyBox(drawtest,"Close","Do you really want to close the application?");
            ab.setBackground(Color.lightGray);        
            ab.setLocation(200,200);
            ab.show();	
            if(ab.close==true)
            	System.exit(0);
            }
        });
    }

    public Draw() {
        super("Java Paintsphere");
        pack();
        setSize(1014,760);
        splashScreen();
        addStuff();
        show();
                
    }

    
	public void splashScreen(){
		
		ImageIcon ic = new ImageIcon("splash.jpg");
		Image simage = ic.getImage();
				    
        JButton jb = new JButton(ic);
        window.add(jb);
        validate();
        
		int imgwidth = simage.getWidth(this);
		int imgheight = simage.getHeight(this);
		window.setLocation(this.getWidth()/2-imgwidth/2,this.getHeight()/2-imgheight/2);
		window.setSize(imgwidth,imgheight);
		if(undecorate < 1)
			window.setUndecorated(true);
		window.show();
		window.toFront();
		try
		{
			Robot r = new Robot();
			r.delay(5000);
	    }
	    catch(Exception e)
	    {;}
	    window.hide();
		window.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
            window.hide();
            }
        });
		
	}		

  	public void helpScreen(){
		
		ImageIcon ic = new ImageIcon("help.gif");
		Image simage = ic.getImage();
				    
        JButton jb = new JButton(ic);
        hwindow.add(jb);
        validate();
        
		int imgwidth = simage.getWidth(this);
		int imgheight = simage.getHeight(this);
		hwindow.setLocation(170,24);
		hwindow.setSize(imgwidth+20,imgheight+22);
		
		hwindow.show();
		hwindow.toFront();
	
		hwindow.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
            hwindow.hide();
            }
        });
		
	}		

    void addStuff(){

        setLayout(new BorderLayout());

        drawingCanvas = new DrawCanvas();
        controls = new DrawControls(drawingCanvas);
      
        add("Center", drawingCanvas); 
        add("West",controls);
        setCursor(HAND_CURSOR);
        ImageIcon ic = new ImageIcon("paint.gif");
		Image imicon = ic.getImage();
        setIconImage(imicon);
        
        drawingCanvas.setVisible(true);
        controls.setVisible(true);
        
        MenuBar menubar = new MenuBar();

        Menu file = new Menu("File");
        Menu edit = new Menu("Edit");
        Menu help = new Menu("Help");
        Menu tools = new Menu("Tools");

        MenuItem Quit = new MenuItem("Quit");
        Quit.addActionListener(this);
        
        MenuItem op = new MenuItem("Open");
        op.addActionListener(this);
        
        MenuItem clo = new MenuItem("Close");
        clo.addActionListener(this);
        
        MenuItem sv = new MenuItem("Save");
        sv.addActionListener(this);
        
        MenuItem abt = new MenuItem("About");
        abt.addActionListener(this);
        
        MenuItem pickitm = new MenuItem("Shade");
        pickitm.addActionListener(this);
        
        MenuItem tx = new MenuItem("Text");
        tx.addActionListener(this);
         
        MenuItem hlp = new MenuItem("Help Topics");
        hlp.addActionListener(this);
        
        file.add(op);
        file.add(sv);
        file.add(clo);
        file.add(Quit);

        edit.add("Cut");
        edit.add("Copy");
        edit.add("Paste");

	    tools.add(tx); 
        help.add(hlp);
        help.add(abt);

        menubar.add(file);
        //menubar.add(edit);
        //menubar.add(tools);
        menubar.add(help);

        dialog = new FileDialog(this,"Open / Import File",FileDialog.LOAD);
        save = new FileDialog(this,"Save File",FileDialog.SAVE);

        setMenuBar(menubar);
       
        tt.addActionListener(this);
        
        Dialog dd = new Dialog(this);
        //Image Bcon = new Image("jicon.gif");
        //dd.add(Bcon);
        dg.setSize(350,150);
        dg.add(tt);
        dg.hide();
        //dg.show();
        
        dg.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
            dg.hide();
            }
        });
    
    }

    public void actionPerformed(ActionEvent e){
    	
    	if(e.getSource() instanceof TextField)
        {
        	System.out.println("Text entry");
        	dg.hide();
        	drawingCanvas.mode = drawingCanvas.TEXT; // 5 for Text enabled mode
        	drawingCanvas.buf = tt.getText();
        	
        }
        if(e.getSource() instanceof MenuItem)
        {
            
            
            if("Quit".equals(e.getActionCommand()))
            {
            
                AnyBox ab = new AnyBox(this,"Shut Down Application ?","Do you really want to quit Java Paintsphere?");
            	ab.setBackground(Color.lightGray);        
	            ab.setLocation(200,200);
	            ab.show();	
	            if(ab.close==true)
	            	System.exit(0);
	            	
            
            
            }
        
            else if("Close".equals(e.getActionCommand()))
            {
            	AnyBox ab = new AnyBox(this,"Close Canvas Image ?","Do want to close the image presently on the canvas?");
    			ab.setBackground(Color.lightGray);        
	            ab.setLocation(200,200);
	            ab.show();	
	            if(ab.close==true)
	            {
	            	drawingCanvas.clear = true;
	            	drawingCanvas.repaint();
	            	
            	}
            	
            }
            
            else if("Open".equals(e.getActionCommand()))
            {
                String Filename;
                dialog.show();
                Filename = dialog.getDirectory()+dialog.getFile();
                
                if(dialog.getFile() !=null)
                {
					drawingCanvas.picImg = Filename;
					drawingCanvas.showSetImg(); 
				}
                
            }
            else if("Save".equals(e.getActionCommand()))
            {
                String Filename;
                save.show();
                Filename = save.getDirectory()+save.getFile();
                if(save.getFile() !=null)
                	drawingCanvas.encodeImg(Filename); 
                
            }
            else if("About".equals(e.getActionCommand()))
            {
                AboutBox ab = new AboutBox(this);
                ab.setBackground(Color.black);
            	ab.setForeground(Color.white);
                ab.setLocation(200,200);
                ab.show();
            }
            else if("Text".equals(e.getActionCommand()))
            {
                dg.show();
            }
            else if("Help Topics".equals(e.getActionCommand()))
            {
                helpScreen();
            }
                       
        } 
        
    }

}




     








