import java.awt.event.*;
import java.awt.geom.*;
import java.awt.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;

public class DrawControls extends Panel implements ActionListener,ItemListener,AdjustmentListener{

    final DrawCanvas target;
    Label label=new Label("Java Paintsphere");
    Color present = Color.white,g1=Color.white,g2=Color.black;
    Image newimg;
    Button bcc = new Button();
    Button bcc2 = new Button();
    Button bbcc = new Button("Grad1");
    Button bbcc2 = new Button("Grad2");
        
    Checkbox aclock = new Checkbox("Clockwise");
    Checkbox hor = new Checkbox("Horizontal");
    Choice sc = new Choice();
    Choice trans = new Choice();
            
    public DrawControls(DrawCanvas target) {

        this.target = target;
        //this.setSize(5,100);
        setLayout(new GridLayout(20,1));

        setBackground(Color.lightGray);
        
        bcc.setSize(30,30);
        bcc2.setSize(30,30);
        bbcc.setSize(30,30);
        bbcc2.setSize(30,30);
        
        aclock.addItemListener(this); 
        hor.addItemListener(this);
        
        Choice shapes = new Choice();
        shapes.addItemListener(this);
        shapes.addItem("Lines");        
        shapes.addItem("Arcs");
        shapes.addItem("Text");
        shapes.addItem("Draw");
        shapes.addItem("Rect");
        shapes.addItem("RoundRect");
        shapes.addItem("Ellip");
        shapes.addItem("FillRect");
        shapes.addItem("FillRoundRect");
        shapes.addItem("FillEllip");
        shapes.addItem("FillArc");
        add(shapes);
        
        Panel panel = new Panel();
        
       
        Choice im = new Choice();
        im.addItemListener(this);
              
        im.addItem("jpeg");
        im.addItem("png");
        im.addItem("bmp");
        im.addItem("tif");
        add(im);
        
        Button impos = new Button("ImagePosition");
        impos.addActionListener(this);
        panel.add(impos);
        //add(impos);
              
        Button clr1 = new Button("Clear") ;
        clr1.addActionListener(this);
        panel.add(clr1);
        add(panel);
        
        Choice imgOp = new Choice();
        imgOp.addItemListener(this);
        imgOp.addItem("Normal");   
        imgOp.addItem("Blur");
        imgOp.addItem("Sharpen");
        imgOp.addItem("Brighten");
        imgOp.addItem("Negative");
        add(imgOp);
        
        Checkbox transp = new Checkbox("Transparent");
        transp.addItemListener(this);
        add(transp);
        
        Scrollbar range = new Scrollbar(Scrollbar.HORIZONTAL, 0, 10, 0, 50);
        range.addAdjustmentListener(this);
 	    add(range);
 	    
 	           
      	Checkbox jmovd = new Checkbox("Dashed Lines");
        jmovd.addItemListener(this);
        add(jmovd);
        
        Choice fontx = new Choice();
        fontx.addItemListener(this);
        GraphicsEnvironment gEnv =
	    GraphicsEnvironment.getLocalGraphicsEnvironment();
		String envfonts[] = gEnv.getAvailableFontFamilyNames();
	
		for ( int i = 1; i < envfonts.length; i++ ) {
		   fontx.addItem(envfonts[i]);
		}


        //fontx.setBackground(Color.lightGray);
        add(fontx);
        
        Choice sh = new Choice();
        sh.addItemListener(this);
        sh.addItem("Normal");   
        sh.addItem("10");
        sh.addItem("20");
        sh.addItem("30");
        sh.addItem("40");
        sh.addItem("50");
        sh.addItem("60");
        sh.addItem("70");
        sh.addItem("80");
        add(sh);
        
     
               
        Checkbox jmov = new Checkbox("Transform");
        jmov.addItemListener(this);
               
        
        trans.addItemListener(this);
        //trans.addItem("Transform");        
        trans.addItem("Rotate");
        trans.addItem("Scale");
        trans.addItem("Shear");
                 
        //trans.setBackground(Color.lightGray);
        /*add(trans);
        add(aclock);
        add(hor);
        */
        
        sc.addItemListener(this);
        sc.addItem(" Scale + "); 
        sc.addItem(" Scale - ");                  
        //add(sc);
        
        bcc.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    Color newColor = JColorChooser.showDialog(
                                                DrawControls.this,
                                                "Choose Foreground Color",
                                                Color.white);
                    if (newColor != null) {
                        
                        present = newColor;
                        DrawControls.this.FcolorChange();                        
                    }
                }
            }
        );
        
        
        bcc2.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    Color newColor = JColorChooser.showDialog(
                                                DrawControls.this,
                                                "Choose Background Color",
                                                Color.white);
                    if (newColor != null) {
                        
                        present = newColor;
                        DrawControls.this.BcolorChange();                        
                    }
                }
            }
        );
        
//-------------------------------------GRADIENT BUTTONS ----------------------------------				                
         
         bbcc.addActionListener(
				            new ActionListener() {
				                public void actionPerformed(ActionEvent e) {
				                    Color newColor = JColorChooser.showDialog(
				                                                DrawControls.this,
				                                                "Choose Foreground Color",
				                                                Color.white);
				                    if (newColor != null) {
				                        
				                        g1 = newColor;
				                        DrawControls.this.g1colorChange();                        
				                    }
				                }
				            }
				        );
				        
				        
				        bbcc2.addActionListener(
				            new ActionListener() {
				                public void actionPerformed(ActionEvent e) {
				                    Color newColor = JColorChooser.showDialog(
				                                                DrawControls.this,
				                                                "Choose Background Color",
				                                                Color.white);
				                    if (newColor != null) {
				                        
				                        g2 = newColor;
				                        DrawControls.this.g2colorChange();                        
				                    }
				                }
				            }
				        );
				        
//-------------------------------------GRADIENT BUTTONS END----------------------------------				        
        
        bcc.setBackground(target.getForeground());
        bcc2.setBackground(target.getBackground());
       
        add(bcc);
        add(bcc2);
        
        Checkbox jmov2 = new Checkbox("Gradient Paint");
        jmov2.addItemListener(this);
        add(jmov2);    
        
        add(jmov);
        /*ImageIcon Bcon = new ImageIcon("small.jpg");
        JButton jb = new JButton(Bcon);
        add(jb);
        validate();
        */
       
        bcc.setVisible(true);
        bcc2.setVisible(true);
        
                       
        // last added component into DrawControls Panel
       
        this.setVisible(true);

    }   
    
    public void FcolorChange()
    {
    	target.setForeground(present);
    	bcc.setBackground(target.getForeground());
    } 
    
    public void BcolorChange()
    {
    	target.setBackground(present);
    	bcc2.setBackground(target.getBackground());
    }  
    
    public void g1colorChange()
    {
    	target.grad1 = g1;
    	target.fill=true;
    	//bcc.setBackground(target.getForeground());
    } 
    
    public void g2colorChange()
    {
    	target.grad2 = g2;
    	target.fill=true;
    	//bcc2.setBackground(target.getBackground());
    }                        
                          
        
    public void paint(Graphics g) {
	      
        /*Rectangle r = getBounds();
        g.setColor(Color.black);
        g.draw3DRect(0, 0, r.width, r.height, false);

        int n = getComponentCount();
        for(int i=0; i<n; i++) {
            Component comp = getComponent(i);
            if (comp instanceof Checkbox) {
                Point loc = comp.getLocation();
                Dimension d = comp.getSize();
                g.setColor(comp.getForeground());
                g.drawRect(loc.x-1, loc.y-1, d.width+1, d.height+1);
            }
        }
        */
        ImageIcon ic = new ImageIcon("paint.gif");
		Image imxx = ic.getImage();
	    g.drawImage(imxx, 27, 620, this);
	    
        
    }
    

    public void actionPerformed(ActionEvent e)
    {
        String command = e.getActionCommand();

        if (e.getSource() instanceof Button)
        {
               command = e.getActionCommand();
               if(command.equals("Clear"))
               {
                    target.setClear(true);
                    target.repaint();
               }
               else if(command.equals("ImagePosition"))
               {
                    target.setDrawMode(DrawCanvas.IMAGE);
                    target.repaint();
               }
                   
                   
        }


      
        else if (e.getSource() instanceof TextField)
        {
               command = e.getActionCommand();
        }

    }
        
    public void adjustmentValueChanged(AdjustmentEvent e)
    {
    	if (e.getSource() instanceof Scrollbar) 
        {
        	target.sstrokew((float)e.getValue()); 
        	
        }
    }
    
    
    public void itemStateChanged(ItemEvent e) {

        if (e.getSource() instanceof Checkbox) 
        {
        	String command = (String) e.getItem();
        	 
        	if(command.equals("Clockwise"))
            {
            	if(target.clock == true)
            		target.clock = false;
            	else if(target.clock == false)
            		target.clock = true;
            }
            
            if(command.equals("Horizontal"))
            {
            	if(target.hor == true)
            		target.hor = false;
            	else if(target.hor == false)
            		target.hor = true;
            }
        	if(command.equals("Transparent")){
              	
             
                if(target.transparent == 0)
            		target.transparent = 1;
            	else if(target.transparent == 1)
            		target.transparent = 0;

            }
        	
        	if(command.equals("Transform"))
        	{
                if(target.motion==false)
                {
                    target.motion=true;
                    this.add(trans);
			        this.add(aclock);
        			this.add(hor);
               		this.add(sc);
               		this.validate();

                    //target.trans="Translate";
                }
                else if(target.motion==true)
                {
                    target.motion=false;
                    target.trans="None";
                    this.remove(trans);
			        this.remove(aclock);
        			this.remove(hor);
               		this.remove(sc);
               		this.validate();
                    
                    //target.r.x1=target.r.y1=-6;
                    //target.r.x2=target.r.y2=-6;
                }
              
              	               
	            //target.repaint();
            
                    
            }
            
            else if(command.equals("Dashed Lines"))
        	{
        		
        		if(!target.strokestr.equals("dashed"))
                {
                    target.strokestr="dashed";
                    //target.trans="Translate";
                }
                else if(target.strokestr.equals("dashed"))
                {
                    target.strokestr="plain";
                }
  
        	}
        
            else if(command.equals("Gradient Paint"))
            {
                if(target.gra==false)
                {
                    target.gra=true;
                    
				        
				        this.add(bbcc);
        				this.add(bbcc2);
        				this.validate();
                }
                
                else if(target.gra==true)
                {
                    target.gra=false;
                    this.remove(bbcc);
        			this.remove(bbcc2);
        			this.validate();
                }
             }   

        }            
        if (e.getSource() instanceof Choice) {
            String choice = (String) e.getItem();

            if (choice.equals(" Scale + ")) {
                target.scaleplus=true; 
            }

            else if (choice.equals(" Scale - ")) {
                target.scaleplus=false;
            }
            if (choice.equals("Lines")) {
                target.setDrawMode(DrawCanvas.LINES); 
            }

            else if (choice.equals("Draw")) {
                target.setDrawMode(DrawCanvas.POINTS);
            }
            
            else if (choice.equals("Rect")) {
                target.setDrawMode(DrawCanvas.RECT);
                target.round = false;
                target.setFillMode2(false);
            }

            else if (choice.equals("RoundRect")) {
                target.setDrawMode(DrawCanvas.RECT);
                target.round = true;
                target.setFillMode2(false);
            }

            else if (choice.equals("Ellip")) {
                target.setDrawMode(DrawCanvas.ELLIPSE);
                target.setFillMode2(false);
            }

            else if (choice.equals("FillRect")) {
                target.setDrawMode(DrawCanvas.RECT);
                target.round = false;
                target.setFillMode2(true);
            }

            else if (choice.equals("FillRoundRect")) {
                target.setDrawMode(DrawCanvas.RECT);
                target.round = true;
                target.setFillMode2(true);
            }

            else if (choice.equals("FillEllip")) {
                target.setDrawMode(DrawCanvas.ELLIPSE);
                target.setFillMode2(true);

            }
            
            else if (choice.equals("FillArc")) {
                target.setDrawMode(DrawCanvas.ARC);
                target.setFillMode2(true);

            }
            
            else if (choice.equals("Arcs")) {
                target.setDrawMode(DrawCanvas.ARC);
                target.setFillMode2(false);

            }
            
            else if (choice.equals("Text")) {
                target.setDrawMode(DrawCanvas.TEXT);
                target.setFillMode2(false);
                target.requestFocus();
                
            }
            
            if (choice.equals("Normal")) {
                //target.setDrawMode(DrawCanvas.ARC);
              
                target.fontsiz = 5;

            }
            
            else if (choice.equals("10")) {
               
                target.fontsiz = 10;


            }
            
            else if (choice.equals("20")) {
                //target.setDrawMode(DrawCanvas.TEXT);
               
                 target.fontsiz = 20;

            }
            
            else if (choice.equals("30")) {
                //target.setDrawMode(DrawCanvas.ARC);
               
                 target.fontsiz = 30;

            }
            
            else if (choice.equals("40")) {
                //target.setDrawMode(DrawCanvas.TEXT);
                
                 target.fontsiz = 40;

            }
            
            else if (choice.equals("50")) {
                
                 target.fontsiz = 50;


            }
            
            else if (choice.equals("60")) {
               
                target.fontsiz = 60;


            }
            
            else if (choice.equals("70")) {
                //target.setDrawMode(DrawCanvas.ARC);
                
                target.fontsiz = 70;


            }
            
            else if (choice.equals("80")) {
               
                target.fontsiz = 80;


            }
            
                     
            if (choice.equals("png")){
              	
                //target.setDrawMode(DrawCanvas.ARC);
                target.imgformat = "png";

            }
            
            else if (choice.equals("jpeg")) {
                //target.setDrawMode(DrawCanvas.TEXT);
                target.imgformat = "jpg";

            }
            
            else if (choice.equals("tif")) {
                //target.setDrawMode(DrawCanvas.TEXT);
                target.imgformat = "tiff";

            }
            
            else if (choice.equals("bmp")) {
                //target.setDrawMode(DrawCanvas.TEXT);
                target.imgformat = "bmp";

            }
            
            if (choice.equals("Normal")){
              	
               
                target.ImOp = 0;

            }
           
            else if(choice.equals("Blur")){
              	
              
                target.ImOp = target.BLUR;

            }
            else if(choice.equals("Sharpen")){
              	
                
                target.ImOp = target.SH;
            }
            else if(choice.equals("Brighten")){
              	
                
                target.ImOp = target.RESC;
            }
            else if(choice.equals("Negative")){
             	
                
                target.ImOp = target.NEG;

            }
          
                      
			GraphicsEnvironment gEnv =
		    GraphicsEnvironment.getLocalGraphicsEnvironment();
			String envfonts[] = gEnv.getAvailableFontFamilyNames();
		
			for ( int i = 1; i < envfonts.length; i++ ) {
				if(choice.equals(envfonts[i]))
			   		target.font = envfonts[i];
			}                        
	           
		    String command = (String)e.getItem();
		    
		     
		       if(command.equals("Rotate"))
		       {
		       	    target.trans="Rotate";
		       	           
		            target.repaint();
		       }
		     
		       else if(command.equals("Shear") )
		       {
		       		target.trans="Shear";
		        	
		       		target.repaint();
		       }
		       else if(command.equals("Scale") )
		       {
		       		target.trans="Scale";
		        
		       		target.repaint();
		       }
		      
            
        }

    }

}
	